#!/usr/bin/env ruby

require 'App42_Ruby_API'

#sa = App42RubyAPI::ServiceAPI.new('f802d9cfdb500cb83e16e3095406ca070be04fe6cf831bb4f1009f31277ac770','70e679b2fe644fb70c1d3251911dea1c43b99b303124c27d2ee9e55ee9331f38')
#sa.buildUserService


class SampleApp

  @@api = App42RubyAPI::ServiceAPI.new("fa5b7135ee896bc6301aca1025173e69ef8215fbb5ab4f4186e487b7e47fe3ef","858075d7ad4c8471de1b3ae08b5ee3c1fc2685153861deb97c33f6cf5ceacb5c")
  @@user_obj = @@api.build_user_service


  #@@api = App42RubyAPI::ServiceAPI.new("fa5b7135ee896bc6301aca1025173e69ef8215fbb5ab4f4186e487b7e47fe3ef","858075d7ad4c8471de1b3ae08b5ee3c1fc2685153861deb97c33f6cf5ceacb5c")
  #@@storageService = @@api.buildStorageService

  #@@pushnotificationService = @@api.buildPushnotificationService

  #@@UploadService_upload = @@api.buildUploadService

  #@@sessionService = @@api.buildSessionService

  #@@geoService = @@api.buildGeoService

  #@@albumService = @@api.buildAlbumService

  #@@logService = api.buildLogService

  #@@recommenderService = @@api.buildRecommenderService

  #@@gameService = @@api.buildGameService

  # Create new User
  def create_user
    begin
      user = @@user_obj.create_user("pravin1", "123456","pravin1@shephertz.com")
      puts " User Creation Successfull !!! JSON Response is : " + user.to_s
    rescue App42BadParameterException => ex
      puts "App42BadParameterException "
      puts "User already exist with given user name" if ex.app_error_code == 2001
    rescue App42SecurityException => ex
      puts "App42SecurityException "
      if ex.app_error_code == 1401
      end
    rescue App42Exception =>ex
      puts "App42Exception "
    end
  end

  # Get User
  def get_user
    begin
      user = @@user_obj.get_user('pravin3')
      puts" User Creation Successfull !!! JSON Response is : " + user.to_s
    rescue App42Exception =>ex
      puts "App42Exception "
    end
  end

  def create_user_with_role
    user_name = "pravin12"
    pwd = "123456"
    email_id = "pravin12@shephertz.com"
    role_list = %w[Admin Manager Programmer Tester]
    user = @@user_obj.create_user_with_role(user_name,pwd,email_id,role_list)
    puts "User name is #{user.userName}"
    puts "email is #{user.email}"
    user_role_list  = user.roleList
    user_role_list.each { |role| puts "role is #{role}" }
    jsonResponse = user.to_s
  end

  def assign_roles
    user_name = "pravin"
    role_list = %w[Admin Manager Tester]
    user = @@user_obj.assign_roles(user_name, role_list)
    puts "userName is #{user.userName}"
    user_role_list = user.roleList
    for roles in user_role_list do
      puts "role is #{roles}"
    end
    jsonResponse = user.to_s
  end

  def get_roles_by_user
    user_name = "pravin4"

    user = @@user_obj.get_roles_by_user(user_name)
    puts "userName is #{user.userName}"
    puts "email is #{user.email}"
    userRoleList = user.roleList
    puts "firstName is #{user.profile.firstName}"
    jsonResponse = user.to_s
  end

  def get_users_by_role
    role = "Admin"

    user_list = @@user_obj.get_users_by_role(role)
    puts "User name is #{user_list.userName}"
    puts "email is #{user_list.email}"
    puts "firstName #{user_list.profile.firstName}"
    userRoleList = user_list.roleList
    jsonResponse = user_list.to_s
  end

  def get_all_users
    user_list = @@user_obj.get_all_users
    user_list.each { |user|
      puts "userName is #{user.userName}"
      puts "email is #{user.email}"
      puts "firstName #{user.profile.firstName}"
    }
    jsonResponse = user_list.to_s
  end



  ## Storage
  def insert_json_document
    dbName = "test"
    collectionName = "foo"
    json = "{\"employeeName \":\"Nick\"}"

    storage = @@storageService.insert_json_document(dbName,collectionName,json)
    #storage = @@storageService.insertJSONDocument(dbName,collectionName,json)
    puts "dbName is #{storage.dbName}"
    puts "collectionName is #{storage.collectionName}"
    jsonDocList = Array.new
    jsonDocList = storage.getJsonDocList
    for jsonDoc in jsonDocList
      puts "docId is #{jsonDoc.docId}"
      puts "JsonDoc is #{jsonDoc.jsonDoc}"
    end
    jsonResponse = storage.to_s
  end

  ##  Push notification
  def send_push_message_to_channel
    channel = "News Channel"
    message = "Message which you have to send"

    pushNotification = @@pushnotificationService.send_push_message_to_channel(channel, message)
    puts "Message is #{pushNotification.message}"
    channelList = Array.new
    channelList = pushNotification.channelList

    for channelObj in channelList
      puts "Channel Name is #{channelObj.name}"
    end

    jsonResponse = pushNotification.to_s
  end


  ## upload
  def upload_file
    name = "TextFile007"
    filePath = "Local file path"
    fType = App42::Upload::UploadFileType.new
    uploadFileType = fType.enum("IMAGE")
    description = "TextFile_123"

    upload = @@uploadService.upload_file(fileName, filePath, fType, uploadFileType, description)
    fileList = Array.new
    fileList =  upload.fileList
    for file in fileList do
      puts "fileName is #{file.name}"
      puts "fileType is #{file.type}"
      puts "url is #{file.url}"
      puts "description is #{file.description}"
    end
    jsonResponse = upload.to_s
  end


  # Session
  def get_session
    uName = "Nick"

    session = @@sessionService.get_session(uName)
    puts "userName is #{session.userName}"
    puts "sessionId is #{session.sessionId}"
    puts "createdOn #{session.createdOn}"
    jsonResponse = session.to_s
  end

  # Geo
  def create_geo_points
    geoStorageName = "geoTest"

    geoList = Array.new
    gp = App42::Geo::GeoPoint.new
    gp.lat = "-74.2713"
    gp.lng = "40.73137"
    gp.marker = "Maplewood, NJ"
    geoList.push(gp)

    geo = @@geoService.create_geo_points(geoStorageName,geoList)
    puts "storageName is #{geo.getStorageName}"
    pointList = Array.new
    pointList = geo.pointList
    for point in pointList do
      puts "lat is #{point.lat}"
      puts "lng is #{point.lng}"
      puts "marker is #{point.marker}"
    end
    jsonResponse = geo.to_s
  end

  # Gallery
  def create_album
    userName = "Nick"
    albumName = "MyAlbum"
    albumDescription = "Album Description"

    album = @@albumService.create_album(userName,albumName,albumDescription)
    puts "albumName is #{album.name}"
    puts "userName is #{album.userName}"
    puts "albumDescription is #{album.albumDescription}"
    jsonResponse = album.to_s
  end

  # Log
  def info
    message = "Info logs"
    #module = "testmod"

    log = @@logService.info(message, appModule)
    messageList = Array.new
    messageList =  log.messageList
    for message in messageList do
      puts "message is #{message.message}"
      puts "appModule is #{message.module}"
      puts "type is #{message.type}"
      puts "logTime is #{message.logTime}"
    end
    jsonResponse = log.to_s
  end

  # Recomendation
  def load_preference_file
    preferenceFilePath = "Local file path"

    recommender =  @@recommenderService.load_preference_file(preferenceFilePath)
    success = recommender.isResponseSuccess
    jsonResponse = recommender.to_s
  end

  # Game
  def create_game
    gameName = "Game01"
    gameDescription = "GameDescription001"

    game = @@gameService.create_game(gameName,gameDescription)
    puts "gameName is #{game.name}"
    puts "gameDescription is #{game.description}"
    jsonResponse = game.to_s
  end

end

obj = SampleApp.new
## User
#obj.create_user
#obj.get_user
obj.create_user_with_role
#obj.assign_roles
#obj.get_roles_by_user  --> Need to work
#obj.get_users_by_role  --> Need to work
#obj.get_all_users

## Storage
#obj.insert_json_document


## Push notification
#obj.send_push_message_to_channel

## Upload
#obj.upload_file

# Session
#obj.get_session

# Geo
#obj.create_geo_points

# Gallery
#obj.create_album

# Log
#obj.info

# Recomendation
#obj.load_preference_file

# Game
#obj.create_game
